package samples;

/**
 * Class that parses the responses for certain fields
 *
 * @author Felix Yang
 */

public class requestParser {
	
	public static String getAPIKey(String response){
		try {
			String r = response.substring(response.indexOf("APIKey") + 10);
			return r.substring(0, r.indexOf("\""));
		}catch (StringIndexOutOfBoundsException e) {
			System.out.println("API Key not found in the response");
			return "";
		}
	}
	
	public static String getDocID(String response){
		try {
			String r = response.substring(response.indexOf("documents"));
			System.out.println(r);
			r = r.substring(r.indexOf("\"id\": ") + 6);
			return r.substring(0, r.indexOf(","));
		}catch (StringIndexOutOfBoundsException e) {
			System.out.println("There is no document ID in the response");
			return "";
		}
	}
	
	public static String getFileID(String response) {
		try {
			String r = response.substring(response.indexOf("files"));
			r = r.substring(r.indexOf("\"id\": ") + 6);
			return r.substring(0, r.indexOf(","));
		}catch (StringIndexOutOfBoundsException e) {
			System.out.println("There is no file ID in the response");
			return "";
		}
	}
}
