package samples;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;

/**
 * (Write a succinct description of this class here. You should avoid
 * wordiness and redundancy. If necessary, additional paragraphs should
 * be preceded by <p>, the html tag for a new paragraph.)
 *
 * <p>Bugs: (a list of bugs and other problems)
 *
 * @author (your name)
 */
public class requests {
	
	public static String post(String URL, String data, String auth) {
		  HttpURLConnection connection = null;

		  try {
		    //Create connection
		    URL url = new URL(URL);
		    connection = (HttpURLConnection) url.openConnection();
		    connection.setRequestMethod("POST");
		    connection.setRequestProperty("Content-Type", "application/json; utf-8");
		    
		    // Provide authentication if needed
		    if (auth != null) connection.setRequestProperty("Authorization", auth);
		    connection.setUseCaches(false);
		    connection.setDoOutput(true);

		    // Writing the data in the POST Request
		    try(OutputStream os = connection.getOutputStream()) {
		        byte[] input = data.getBytes("utf-8");
		        os.write(input, 0, input.length);           
		    }
		    
		    // Convert Response to String
		    InputStream is = connection.getInputStream();
		    BufferedReader rd = new BufferedReader(new InputStreamReader(is));
		    StringBuilder response = new StringBuilder();
		    String line;
		    while ((line = rd.readLine()) != null) {
		      response.append(line);
		      response.append('\r');
		    }
		    rd.close();
		    return response.toString();
		  } catch (Exception e) {
		    e.printStackTrace();
		    return null;
		  } finally {
		    if (connection != null) {
		      connection.disconnect();
		    }
		  }
		}
	
	public static String get(String targetURL, String auth) {
		  HttpURLConnection connection = null;
		  try {
		    // Create connection
		    URL url = new URL(targetURL);
		    connection = (HttpURLConnection) url.openConnection();
		    connection.setRequestMethod("GET");
		    
		    // Provide authentication if needed
		    if (auth != null) connection.setRequestProperty("Authorization", auth);
		    connection.setUseCaches(false);
		    connection.setDoOutput(true);

		    // Convert Response to String
		    InputStream is = connection.getInputStream();
		    BufferedReader rd = new BufferedReader(new InputStreamReader(is));
		    StringBuilder response = new StringBuilder();
		    String line;
		    while ((line = rd.readLine()) != null) {
		      response.append(line);
		      response.append('\r');
		    }
		    rd.close();
		    return response.toString();
		  } catch (Exception e) {
		    e.printStackTrace();
		    return null;
		  } finally {
		    if (connection != null) {
		      connection.disconnect();
		    }
		  }
		}
	
	public static String delete(String targetURL, String auth) {
		  HttpURLConnection connection = null;
		  try {
		    // Create connection
		    URL url = new URL(targetURL);
		    connection = (HttpURLConnection) url.openConnection();
		    connection.setRequestMethod("DELETE");
		    
		    // Provide authentication if needed
		    if (auth != null) connection.setRequestProperty("Authorization", auth);
		    connection.setUseCaches(false);
		    connection.setDoOutput(true);

		    // Convert Response to String
		    InputStream is = connection.getInputStream();
		    BufferedReader rd = new BufferedReader(new InputStreamReader(is));
		    StringBuilder response = new StringBuilder();
		    String line;
		    while ((line = rd.readLine()) != null) {
		      response.append(line);
		      response.append('\r');
		    }
		    rd.close();
		    return response.toString();
		  } catch (Exception e) {
		    e.printStackTrace();
		    return null;
		  } finally {
		    if (connection != null) {
		      connection.disconnect();
		    }
		  }
		}
	
	public static String put(String URL, String data, String auth) {
		  HttpURLConnection connection = null;

		  try {
		    //Create connection
		    URL url = new URL(URL);
		    connection = (HttpURLConnection) url.openConnection();
		    connection.setRequestMethod("PUT");
		    connection.setRequestProperty("Content-Type", "application/json; utf-8");
		    
		    // Provide authentication if needed
		    if (auth != null) connection.setRequestProperty("Authorization", auth);
		    connection.setUseCaches(false);
		    connection.setDoOutput(true);

		    // Writing the data in the POST Request
		    try(OutputStream os = connection.getOutputStream()) {
		        byte[] input = data.getBytes("utf-8");
		        os.write(input, 0, input.length);           
		    }
		    
		    // Convert Response to String
		    InputStream is = connection.getInputStream();
		    BufferedReader rd = new BufferedReader(new InputStreamReader(is));
		    StringBuilder response = new StringBuilder();
		    String line;
		    while ((line = rd.readLine()) != null) {
		      response.append(line);
		      response.append('\r');
		    }
		    rd.close();
		    return response.toString();
		  } catch (Exception e) {
		    e.printStackTrace();
		    return null;
		  } finally {
		    if (connection != null) {
		      connection.disconnect();
		    }
		  }
		}
}
